// sf_read.cpp
//   (C)2010 Orion / orio-n
// l^ ...
//   sf2mrtg
//   (C) 2007 INOUE Hirokazu
//   GNU General Public License, free software

#include "stdafx.h"
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <windows.h>
#include "sf_read.h"

int _tmain(int argc, _TCHAR* argv[])
{
	__sr_prof_data srProf;
	__sr_read_data srReadData;
	int i;

	// -h/-? IvVtꂽƂɂ́Aʂɕ\
	if(argc == 2)
	{
		if(!strcmp(argv[1], "/?") || !strcmp(argv[1], "/h") || !strcmp(argv[1], "-h") || !strcmp(argv[1], "-?"))
			puts("sf_read\n\tRead SpeedFan Shared Memory data\n\n"
			"Usage\n\tsf_read [-h?]\n"
			"Options\n\t-h/-?\tdisplay this help\n"
			"Configuration File\n"
			"\tsf_read.ini, in the same directory of sf_read.exe\n"
			"\tConfiguration file is automatically made,\n\tif it doesn't exists at sf_read.exe folder.\n\n"
			"Return Value\n"
			"\tif success, return 0. otherwise return 1\n"
			"Copyright\n"
			"\t(C) 2007 INOUE. Hirokazu / (C) 2010 Orion\n"
			"\tThis program is free software: you can use this under the GNU\n"
			"\tGeneral Public License, for details see sf_read.txt\n");

		return 1;
	}

	// INIt@Cݒlǂݍ
	// iINIt@C݂ȂƂɂ́AINIt@C쐬j
	if(GetInitData(&srProf) != 0)
	{
		puts("0\n0\n0\nError (INI file error)\n");
		return 1;	// ǂݍ݃G[ iINIt@CVK쐬j
	}

	if(!strcmp(srProf.sMode, "sharemem"))
	{
		// SpeedFan  L[ f[^ǂݍ
		if(ReadSpeedfanSharedMemory(&srProf, &srReadData) != 0)
		{
			puts("0\n0\n0\nError (SpeedFan Shared Memory read error)\n");
			return 1;	// ǂݍ݃G[
		}
	}
	else
	{
		puts("0\n0\n0\nError (mode must be sharemem/csv)\n");
		return 1;	// ǂݍ݃G[
	}

	// o̓t@C쐬
	FILE*	fp = fopen(srProf.sOutputFile, "w");
	if(fp == NULL)	return 1;

	// x/t@]/d o
	for(i = 0; i < srReadData.numTemps; i++)	fprintf(fp, "temp%d\t%d\n", i, srReadData.nTemp[i]);
	for(i = 0; i < srReadData.numFans; i++)		fprintf(fp, "fan%d\t%d\n", i, srReadData.nFan[i]);
	for(i = 0; i < srReadData.numVolts; i++)	fprintf(fp, "voltage%d\t%d\n", i, srReadData.nVoltage[i]);

	fclose(fp);

	// Windows N̎Ԃ𓾂
	//nUptime = GetTickCount();
	//sprintf(sUptime, srProf.sOutputUptimeStr, nUptime/(24*3600000L), (nUptime/3600000L)%24, (nUptime/60000)%60);

	// ʕ\@imrtg̃f[^\ɂ̂ƂA4s\j
	//printf("%d\n%d\n%s\n%s\n", nMbTemp, nCpuTemp, sUptime, srProf.sOutputTempStr);

	return 0;		// I
}


// INI t@Cݒlǂݍ
int GetInitData(__sr_prof_data *srProf)
{
	char sModulePath[1024];
	char *sPtr;
	char sTemp[1024];
	int i;
	size_t nStrSize;

	// ݂̃W[̃tpX𓾂
	i = GetModuleFileName(NULL, sTemp, 1023);
	if(i<=0 || i>=1023) {
		puts("݂̃vZX̃pXȂ\n");
		return 1;		// ݂̃vZX̃pXȂ
	}

	// W[pX̍Ō . ̈ʒu܂łt@C̃{fBƂ
	sPtr = strrchr(sTemp, '.');
	if(sPtr == NULL)
		nStrSize = strlen(sTemp);		// . ꍇApXŜƂ
	else
		nStrSize = strlen(sTemp) - strlen(sPtr);
	strncpy(sModulePath, sTemp, nStrSize);
	sModulePath[nStrSize] = (char)NULL;

	// INI gq
	strcat(sModulePath, ".ini");


	// INIt@C݂邩̊mF
	GetPrivateProfileString("sf_read", "install", "err", sTemp, 1023, sModulePath);
	if(!strcmp(sTemp, "err"))
	{
		WriteInitIniFile();		// INI mFłȂꍇAVK쐬
		puts("INIt@CVK쐬\n");
		return 1;
	}


	// ݒlǂݍ

	GetPrivateProfileString("sf_read", "Mode", "err", srProf->sMode, 31, sModulePath);
	if(!strcmp(srProf->sSpeedfanPath, "err")) return 1;			// ݒlǂݍݕs\

	GetPrivateProfileString("sf_read", "SpeedFanPath", "err", srProf->sSpeedfanPath, 1023, sModulePath);
	if(!strcmp(srProf->sSpeedfanPath, "err")) return 1;			// ݒlǂݍݕs\

	GetPrivateProfileString("sf_read", "OutputFile", "err", srProf->sOutputFile, 1023, sModulePath);
	if(!strcmp(srProf->sOutputFile, "err")) return 1;			// ݒlǂݍݕs\

	GetPrivateProfileString("sf_read", "numTemps", "err", sTemp, 1023, sModulePath);
	if(!strcmp(sTemp, "err")) return 1;							// ݒlǂݍݕs\
	srProf->numTemps = atoi(sTemp);

	GetPrivateProfileString("sf_read", "numFans", "err", sTemp, 1023, sModulePath);
	if(!strcmp(sTemp, "err")) return 1;							// ݒlǂݍݕs\
	srProf->numFans = atoi(sTemp);

	GetPrivateProfileString("sf_read", "numVolts", "err", sTemp, 1023, sModulePath);
	if(!strcmp(sTemp, "err")) return 1;							// ݒlǂݍݕs\
	srProf->numVolts = atoi(sTemp);

	return 0;
}


// VKINIt@C쐬
void WriteInitIniFile(void)
{
	char sModulePath[1024];
	char *sPtr;
	char sTemp[1024];
	int i;
	size_t nStrSize;

	// ݂̃W[̃tpX𓾂
	i = GetModuleFileName(NULL, sTemp, 1023);
	if(i<=0 || i>=1023) return ;		// ݂̃vZX̃pXȂ


	// W[pX̍Ō . ̈ʒu܂łt@C̃{fBƂ
	sPtr = strrchr(sTemp, '.');
	if(sPtr == NULL)
		nStrSize = strlen(sTemp);		// . ꍇApXŜƂ
	else
		nStrSize = strlen(sTemp) - strlen(sPtr);
	strncpy(sModulePath, sTemp, nStrSize);
	sModulePath[nStrSize] = (char)NULL;

	// INI gq
	strcat(sModulePath, ".ini");

	// TvINIt@C

	if(!WritePrivateProfileString("sf_read", "install", "installed (this is for detection of ini file)", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "Mode", "sharemem", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "SpeedFanPath", "c:\\Program Files\\SpeedFan\\", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "OutputPath", "c:\\sf_read.txt", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "numTemps", "1", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "numFans", "1", sModulePath))
		return ;
	if(!WritePrivateProfileString("sf_read", "numVolts", "1", sModulePath))
		return ;

	return ;
}

// SpeedFan  L[ Axf[^ǂݍ
int ReadSpeedfanSharedMemory(__sr_prof_data *srProf, __sr_read_data *srReadData)
{
	HANDLE hSfmem;
	__speedfan_shared_memory *pSfmem;
	int i;

	// SpeedFan L[IuWFNgJ
	hSfmem = OpenFileMapping(FILE_MAP_READ, FALSE, "SFSharedMemory_ALM");
	if(hSfmem == NULL)
		return 1;		// G[

	// ̃vZX̃obt@ԂɁAL̃[Ԃ}bsO
	pSfmem = (__speedfan_shared_memory *)MapViewOfFile(hSfmem, FILE_MAP_READ, 0, 0, sizeof(__speedfan_shared_memory));
	if(pSfmem == NULL)
	{
		CloseHandle(hSfmem);
		return 1;		// G[
	}

	// Jl̕s
	if(srProf->numTemps<=0 || srProf->numTemps>=32 ||
		srProf->numFans<=0 || srProf->numFans>=32 ||
		srProf->numVolts<=0 || srProf->numVolts>=32 )
		return 1;

	int	numTemps = (srProf->numTemps < pSfmem->numTemps) ? srProf->numTemps : pSfmem->numTemps;
	int	numFans  = (srProf->numFans < pSfmem->numFans) ? srProf->numFans : pSfmem->numFans;
	int	numVolts = (srProf->numVolts < pSfmem->numVolts) ? srProf->numVolts : pSfmem->numVolts;
	srReadData->numTemps = numTemps;
	srReadData->numFans  = numFans;
	srReadData->numVolts = numVolts;

	//printf("Temps:%d Fans:%d Volts:%d\n", numTemps, numFans, numVolts); 
	
	// xl̃Rs[
	for(i = 0; i < numTemps; i++)	srReadData->nTemp[i] = pSfmem->tempsArray[i];
	for(i = 0; i < numFans; i++)	srReadData->nFan[i] = pSfmem->fansArray[i];
	for(i = 0; i < numVolts; i++)	srReadData->nVoltage[i] = pSfmem->voltsArray[i];

	// }bsOAIuWFNg
	UnmapViewOfFile(pSfmem);
	CloseHandle(hSfmem);



	return 0;
}


// EOF
